JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
GenericScopedTryLock< LockType > Class Template Reference
juce_core » threads

Automatically locks and unlocks a mutex object. More...

`#include <juce_ScopedLock.h>`

## Public Member Functions
| GenericScopedTryLock (const LockType &lock, bool acquireLockOnInitialisation=true) noexcept
| Creates a GenericScopedTryLock.
| ~GenericScopedTryLock () noexcept
| Destructor.
bool | isLocked () const noexcept
| Returns true if the mutex was successfully locked.
bool | retryLock () const noexcept
| Retry gaining the lock by calling tryEnter on the underlying lock.

## Detailed Description

template<class LockType>
class GenericScopedTryLock< LockType >

Automatically locks and unlocks a mutex object.

Use one of these as a local variable to provide RAII-based locking of a mutex.

The templated class could be a CriticalSection, SpinLock, or anything else that provides enter() and exit() methods.

e.g.

CriticalSection myCriticalSection;
for (;;)
{
const GenericScopedTryLock<CriticalSection> myScopedTryLock (myCriticalSection);
// Unlike using a ScopedLock, this may fail to actually get the lock, so you
// should test this with the isLocked() method before doing your thread-unsafe
// action..
if (myScopedTryLock.isLocked())
{
...do some stuff...
}
else
{
..our attempt at locking failed because another thread had already locked it..
}
// myCriticalSection gets unlocked here (if it was locked)
}
CriticalSection
A re-entrant mutex.
Definition juce_CriticalSection.h:44
GenericScopedTryLock
Automatically locks and unlocks a mutex object.
Definition juce_ScopedLock.h:199

See also
  CriticalSection::tryEnter, GenericScopedLock, GenericScopedUnlock

## Constructor & Destructor Documentation

## ◆ GenericScopedTryLock()

template<class LockType >

GenericScopedTryLock< LockType >::GenericScopedTryLock | ( | const LockType & | lock,
|  | bool | acquireLockOnInitialisation = true )
| explicit noexcept

Creates a GenericScopedTryLock.

If acquireLockOnInitialisation is true then as soon as this ScopedTryLock is created, it will attempt to acquire the lock with tryEnter.

You can retry acquiring the lock by calling retryLock.

When GenericScopedTryLock is deleted, the lock will be released (if the lock was successfully acquired).

Make sure this object is created and deleted by the same thread, otherwise there are no guarantees what will happen! Best just to use it as a local stack object, rather than creating one with the new() operator.

See also
  retryLock, isLocked

## ◆ ~GenericScopedTryLock()

template<class LockType >

GenericScopedTryLock< LockType >::~GenericScopedTryLock | ( |  | ) |
| noexcept

Destructor.

The mutex will be unlocked (if it had been successfully locked) when the destructor is called.

Make sure this object is created and deleted by the same thread, otherwise there are no guarantees what will happen!

## Member Function Documentation

## ◆ isLocked()

template<class LockType >

bool GenericScopedTryLock< LockType >::isLocked | ( |  | ) | const
| noexcept

Returns true if the mutex was successfully locked.

## ◆ retryLock()

template<class LockType >

bool GenericScopedTryLock< LockType >::retryLock | ( |  | ) | const
| noexcept

Retry gaining the lock by calling tryEnter on the underlying lock.

The documentation for this class was generated from the following file:

- juce_ScopedLock.h